Planning your next event? Here are tips for hackathon guru meditation. _[Skip this page](/event/new)_

## 🏁 Challenges

The starting point of most hackathons: a short description of a problem, some initial ideas of solutions which can be realistically attempted during the time constraints of the event. Once you create your event page, you can attach challenges that the teams should respond to.

<label><input type="checkbox"> Create a series of **Challenges**, which you may want to organize in **Categories**</label><br>
<label><input type="checkbox"> Use the **Quickstart guide** to share tips with challenge owners</label><br>
<label><input type="checkbox"> Create a **Template** event if you would like to speed this part up</label><br>

## 👪 Teams

Some people like to hack on their own - for others, hackathons are all about collaboration and meeting new people. A team generally consists of 3 to 8 people. You can encourage your participants to set up a profile with roles that you can define in the _Presets_ menu to create a smooth team-building process.

<label><input type="checkbox"> Decide what **Roles** are appropriate to your event </label><br>
<label><input type="checkbox"> Encourage participants to create an online **Profile** </label><br>
<label><input type="checkbox"> Facilitate team-building by having everyone try to **Join** a challenge </label><br>

## 📦 Resources

When participants bring their own material, sharing is encouraged as long as the entire team can use them easily and legally, with preference to free, open source/open data, web-accessible. Using a Resource area, you can help participants from a wide range experience levels to get started.

<label><input type="checkbox"> Provide links in your event **Instructions**, such as to collections of open data </label><br>
<label><input type="checkbox"> Set up a **Resources** event with tools and datasets recommended for each stage </label><br>
<label><input type="checkbox"> Customize the event **Stages** with your own hints and progression rules </label><br>

## ☝️ Conduct

In the interest of creating a safe and inclusive environment, we strongly encourage applying a Code of Conduct and open license to your event. We have provided an example at the bottom of every page, which you may modify, and also include a reference to in your opening presentation or e-mailed instructions.

<label><input type="checkbox"> Check the **Community** section in your event settings </label><br>
<label><input type="checkbox"> Make sure your fellow organisers are <u>aware and ready</u> to enforce a Code of Conduct </label><br>
<label><input type="checkbox"> Verify compliance during evaluation rounds, when issuing certificates, or other post-event analysis </label><br>

_Disagree with something?_ Please raise [an issue](https://github.com/dribdat/dribdat/issues) or [Edit this page](https://github.com/dribdat/dribdat/blob/main/dribdat/templates/includes/eventstart.md).
