"""Event status, longer autotext_url, nullables

Revision ID: d834973bc366
Revises: f5ee0fa5649b
Create Date: 2023-03-14 15:16:07.864414

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'd834973bc366'
down_revision = 'f5ee0fa5649b'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('events', schema=None) as batch_op:
        batch_op.add_column(sa.Column('status', sa.UnicodeText(), nullable=True))

    with op.batch_alter_table('projects', schema=None) as batch_op:
        batch_op.alter_column('autotext_url',
               existing_type=sa.VARCHAR(length=255),
               type_=sa.String(length=2048),
               existing_nullable=True)

    with op.batch_alter_table('projects_version', schema=None) as batch_op:
        batch_op.alter_column('name',
               existing_type=sa.VARCHAR(length=80),
               nullable=True,
               autoincrement=False)
        batch_op.alter_column('longtext',
               existing_type=sa.TEXT(),
               nullable=True,
               autoincrement=False)
        batch_op.alter_column('created_at',
               existing_type=sa.DATETIME(),
               nullable=True,
               autoincrement=False)
        batch_op.alter_column('updated_at',
               existing_type=sa.DATETIME(),
               nullable=True,
               autoincrement=False)

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('projects_version', schema=None) as batch_op:
        batch_op.alter_column('updated_at',
               existing_type=sa.DATETIME(),
               nullable=False,
               autoincrement=False)
        batch_op.alter_column('created_at',
               existing_type=sa.DATETIME(),
               nullable=False,
               autoincrement=False)
        batch_op.alter_column('longtext',
               existing_type=sa.TEXT(),
               nullable=False,
               autoincrement=False)
        batch_op.alter_column('name',
               existing_type=sa.VARCHAR(length=80),
               nullable=False,
               autoincrement=False)

    with op.batch_alter_table('projects', schema=None) as batch_op:
        batch_op.alter_column('autotext_url',
               existing_type=sa.String(length=2048),
               type_=sa.VARCHAR(length=255),
               existing_nullable=True)

    with op.batch_alter_table('events', schema=None) as batch_op:
        batch_op.drop_column('status')

    # ### end Alembic commands ###
